<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for registerServer StructType
 * @subpackage Structs
 */
class RegisterServer extends AbstractStructBase
{
    /**
     * The srv
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Server
     */
    public $srv;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for registerServer
     * @uses RegisterServer::setSrv()
     * @uses RegisterServer::setAuth()
     * @param \StructType\Server $srv
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\Server $srv = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setSrv($srv)
            ->setAuth($auth);
    }
    /**
     * Get srv value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Server|null
     */
    public function getSrv()
    {
        return isset($this->srv) ? $this->srv : null;
    }
    /**
     * Set srv value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Server $srv
     * @return \StructType\RegisterServer
     */
    public function setSrv(\StructType\Server $srv = null)
    {
        if (is_null($srv) || (is_array($srv) && empty($srv))) {
            unset($this->srv);
        } else {
            $this->srv = $srv;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\RegisterServer
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegisterServer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
