<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for unregisterDatabase StructType
 * @subpackage Structs
 */
class UnregisterDatabase extends AbstractStructBase
{
    /**
     * The dbhandle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Database
     */
    public $dbhandle;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for unregisterDatabase
     * @uses UnregisterDatabase::setDbhandle()
     * @uses UnregisterDatabase::setAuth()
     * @param \StructType\Database $dbhandle
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\Database $dbhandle = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setDbhandle($dbhandle)
            ->setAuth($auth);
    }
    /**
     * Get dbhandle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Database|null
     */
    public function getDbhandle()
    {
        return isset($this->dbhandle) ? $this->dbhandle : null;
    }
    /**
     * Set dbhandle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Database $dbhandle
     * @return \StructType\UnregisterDatabase
     */
    public function setDbhandle(\StructType\Database $dbhandle = null)
    {
        if (is_null($dbhandle) || (is_array($dbhandle) && empty($dbhandle))) {
            unset($this->dbhandle);
        } else {
            $this->dbhandle = $dbhandle;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\UnregisterDatabase
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnregisterDatabase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
