<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for unregisterFilestore StructType
 * @subpackage Structs
 */
class UnregisterFilestore extends AbstractStructBase
{
    /**
     * The store
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Filestore
     */
    public $store;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for unregisterFilestore
     * @uses UnregisterFilestore::setStore()
     * @uses UnregisterFilestore::setAuth()
     * @param \StructType\Filestore $store
     * @param \StructType\Credentials $auth
     */
    public function __construct(\StructType\Filestore $store = null, \StructType\Credentials $auth = null)
    {
        $this
            ->setStore($store)
            ->setAuth($auth);
    }
    /**
     * Get store value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Filestore|null
     */
    public function getStore()
    {
        return isset($this->store) ? $this->store : null;
    }
    /**
     * Set store value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Filestore $store
     * @return \StructType\UnregisterFilestore
     */
    public function setStore(\StructType\Filestore $store = null)
    {
        if (is_null($store) || (is_array($store) && empty($store))) {
            unset($this->store);
        } else {
            $this->store = $store;
        }
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\UnregisterFilestore
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnregisterFilestore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
